name: Release

on:
  workflow_dispatch:
    inputs:
      semver:
        description: Bump
        required: true
        type: choice
        options:
          - major
          - minor
          - patch

jobs:
  release:
    runs-on: ubuntu-latest
    steps:
      -
        name: Checkout
        uses: actions/checkout@v4
        with:
          fetch-depth: 0
          ssh-key: ${{ secrets.RELEASE_SSH_KEY }}
      -
        name: Set up Ruby 3.2
        uses: ruby/setup-ruby@v1
        with:
          ruby-version: "3.2"
          bundler-cache: true
      -
        name: Update version
        run: |
          git config user.name github-actions
          git config user.email github-actions@github.com
          bundle config unset deployment
          bundle exec rake "version[${{ inputs.semver }}]"
      -
        name: Build and push gem
        run: bundle exec rake release
        env:
          GEM_HOST_API_KEY: ${{ secrets.RUBYGEMS_TOKEN }}
